#pragma ident "$Id: nrts.c,v 1.1 2011/07/27 23:50:56 dechavez Exp $"
/*======================================================================
 *
 * NRTS display
 *
 *====================================================================*/
#include "qmon.h"

#define LABEL " NRTS Disk Loop Status "
static int StartingRow = 0;

void UpdateNRTS(QMON *qmon)
{
WINDOW *win;

    win = qmon->win.isi;

    PrintHostTime(win, 0);
    isidlMonUpdateNRTS(win, &qmon->mon, StartingRow);
    wrefresh(win);
    return;
}

static void SetMonDL(QMON *qmon)
{
LNKLST_NODE *crnt;
DIGITIZER *digitizer;
static char target[MAXPATHLEN+1], *name;

    crnt = listFirstNode(qmon->avail);
    while (crnt != NULL) {
        digitizer = (DIGITIZER *) crnt->payload;
        strncpy(target, digitizer->addr->connect.ident, MAXPATHLEN);
        if (digitizer->win[0] != NULL) break;
        crnt = listNextNode(crnt);
    }

/* At this point we have a name, hopefully of the form siteXX. Truncate it. */

    if (strlen(target) > 2) target[strlen(target)-2] = 0;
    isidlSetMonNRTS(&qmon->mon, target);
}

void SetNRTSdisplay(QMON *qmon)
{
WINDOW *win;
int i, row, col;

    SetMonDL(qmon);
    qmon->mode = QMON_MODE_NRTS;
    win = qmon->win.isi;

    wclear(win);

    row = QMON_LST_ROWS;
    wmove(win, row, 0);
    for (i = 0; i < QMON_COLS; i++) waddch(win, QMON_WIN_BOUNDARY_CHAR);
    col = QMON_NRTS_COLS/2 - strlen(LABEL)/2;
    mvwprintw(win, row++, col, LABEL);
    StartingRow = row;

    isidlMonStaticNRTS(win, StartingRow);

    UpdateNRTS(qmon);
    return;
}

/*-----------------------------------------------------------------------+
 |                                                                       |
 | Copyright (C) 2011 Regents of the University of California            |
 |                                                                       |
 | This software is provided 'as-is', without any express or implied     |
 | warranty.  In no event will the authors be held liable for any        |
 | damages arising from the use of this software.                        |
 |                                                                       |
 | Permission is granted to anyone to use this software for any purpose, |
 | including commercial applications, and to alter it and redistribute   |
 | it freely, subject to the following restrictions:                     |
 |                                                                       |
 | 1. The origin of this software must not be misrepresented; you must   |
 |    not claim that you wrote the original software. If you use this    |
 |    software in a product, an acknowledgment in the product            |
 |    documentation of the contribution by Project IDA, UCSD would be    |
 |    appreciated but is not required.                                   |
 | 2. Altered source versions must be plainly marked as such, and must   |
 |    not be misrepresented as being the original software.              |
 | 3. This notice may not be removed or altered from any source          |
 |    distribution.                                                      |
 |                                                                       |
 +-----------------------------------------------------------------------*/

/* Revision History
 *
 * $Log: nrts.c,v $
 * Revision 1.1  2011/07/27 23:50:56  dechavez
 * created
 *
 */
