#pragma ident "$Id: main.c,v 1.1 2013/03/11 23:04:16 dechavez Exp $"
/*======================================================================
 * 
 * sbds - Iridium Short Burst Data Server
 *
 *====================================================================*/
#include "sbds.h"

#define MY_MOD_ID SBD_MOD_MAIN

static SBD *server;

VOID DisableNewConnections(VOID)
{
    sbdSetDisabled(server, TRUE);
}

/* Main program loop */

static THREAD_FUNC MainThread(MainThreadParams *cmdline)
{
PARAM *par;
SBD *client, *server;
static char buf[128];

/* Load the run time parameters */

    par = LoadPar(cmdline->myname, cmdline->argc, cmdline->argv);

/* Initialize everything */

    server = Init(cmdline->myname, par);

/* Ready to begin */

    LogMsg(LOG_INFO, "listening for SBD messages at port %d\n", par->port);

    while (1) {
        BlockOnShutdown();
        if ((client = sbdAccept(server)) != (SBD *) NULL) {
            if (!ShutdownInProgress()) {
                LogMsg(LOG_DEBUG, "%s: connection established", client->peer.ident);
                ServiceConnection(client);
            } else {
                sbdClose(client);
            }
        } else {
            LogMsg(LOG_WARN, "incoming SBD message failed: %s (ignored)", strerror(errno));
        }
    }
}

#ifdef WIN32_SERVICE
#   include "win32svc.c"
#else

/* Or just run it like a regular console app or Unix program */

#ifdef unix
int main(int argc, char **argv)
#else
VOID main(int argc, char **argv)
#endif
{
MainThreadParams cmdline;

    cmdline.argc   = argc;
    cmdline.argv   = argv;
    cmdline.myname = argv[0];

    MainThread(&cmdline);
}

#endif /* WIN32_SERVICE */

/* Revision History
 *
 * $Log: main.c,v $
 * Revision 1.1  2013/03/11 23:04:16  dechavez
 * initial release
 *
 */
