#pragma ident "$Id: rwfdrec.c,v 1.2 2011/03/17 17:21:09 dechavez Exp $"
/*======================================================================
 *
 *  Read a single wfdisc record.  2.8 format wfdiscs are detected and
 *  converted to 3.0 format silently and automatically.
 *
 *  Records with incorrect length are silently ignored.
 *
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * Copyright (c) 1997 Regents of the University of California.
 * All rights reserved.
 *====================================================================*/
#include <stdio.h>
#include <stdlib.h>
#include "cssio.h"
#include "util.h"

int rwfdrec(fp, wfdisc)
FILE *fp;                 
struct cssio_wfdisc *wfdisc;  
{
static char line[CSSIO_WFDISC_SIZE+2];
struct cssio_wfdisc28 wfdisc28;

    if (SETMODE(fileno(fp), O_BINARY) == -1) {
        perror("library routine rwfdrec: setmode");
        return -1;
    }

    while (1) {

        if (fgets(line, CSSIO_WFDISC_SIZE+1, fp) == NULL) return -1;

        if (strlen(line) == CSSIO_WFDISC28_SIZE) {
            sscanf(line, CSSIO_WFDISC28_SCS, CSSIO_WFDISC28_RVL(&wfdisc28));
            CSSIO_WFDISC28_TRM(&wfdisc28);
            wf28to30(wfdisc, &wfdisc28);
            return 0;
        } else if (strlen(line) == CSSIO_WFDISC_SIZE) {
            sscanf(line, CSSIO_WFDISC_SCS, CSSIO_WFDISC_RVL(wfdisc));
            CSSIO_WFDISC_TRM(wfdisc);
            return 0;
        }
    }
}

/* Revision History
 *
 * $Log: rwfdrec.c,v $
 * Revision 1.2  2011/03/17 17:21:09  dechavez
 * changed all macros and constants to use names with CSSIO_ or cssio_ prefixes
 * in order to avoid conflicts with IDA DCC source code
 *
 * Revision 1.1.1.1  2000/02/08 20:20:23  dec
 * import existing IDA/NRTS sources
 *
 */
