#pragma ident "$Id: string.c,v 1.26 2012/01/17 18:44:47 dechavez Exp $"
/*======================================================================
 *
 * Stirng conversions
 *
 *====================================================================*/
#include "qdp.h"

static QDP_TEXT_MAP CmdMap[] = {
    {"C1_CACK",    QDP_C1_CACK}, 
    {"C1_SRVCH",   QDP_C1_SRVCH},
    {"C1_CERR",    QDP_C1_CERR}, 
    {"C1_MYSN",    QDP_C1_MYSN},
    {"C1_PHY",     QDP_C1_PHY}, 
    {"C1_LOG",     QDP_C1_LOG},
    {"C1_GLOB",    QDP_C1_GLOB}, 
    {"C1_FIX",     QDP_C1_FIX},
    {"C1_MAN",     QDP_C1_MAN}, 
    {"C1_STAT",    QDP_C1_STAT},
    {"C1_RT",      QDP_C1_RT}, 
    {"C1_THN",     QDP_C1_THN},
    {"C1_GID",     QDP_C1_GID}, 
    {"C1_RCNP",    QDP_C1_RCNP},
    {"C1_SPP",     QDP_C1_SPP}, 
    {"C1_SC",      QDP_C1_SC},
    {"C1_FLGS",    QDP_C1_FLGS}, 
    {"C1_DCP",     QDP_C1_DCP},
    {"C1_DEV",     QDP_C1_DEV}, 
    {"C1_MEM",     QDP_C1_MEM},
    {"C1_MOD",     QDP_C1_MOD}, 
    {"C1_FREE",    QDP_C1_FREE},
    {"C2_PHY",     QDP_C2_PHY}, 
    {"C2_GPS",     QDP_C2_GPS},
    {"C2_WIN",     QDP_C2_WIN}, 
    {"C2_AMASS",   QDP_C2_AMASS},
    {"C2_POC",     QDP_C2_POC}, 
    {"C2_BACK",    QDP_C2_BACK},
    {"C2_VACK",    QDP_C2_VACK}, 
    {"C2_BCMD",    QDP_C2_BCMD},
    {"C2_REGRESP", QDP_C2_REGRESP}, 
    {"C2_QV",      QDP_C2_QV},
    {"C2_MD5",     QDP_C2_MD5}, 
    {"C2_SNAPT",   QDP_C2_SNAPT}, 
    {"C2_TERR",    QDP_C2_TERR},
    {"C1_RQSRV",   QDP_C1_RQSRV}, 
    {"C1_SRVRSP",  QDP_C1_SRVRSP},
    {"C1_DSRV",    QDP_C1_DSRV}, 
    {"C1_SAUTH",   QDP_C1_SAUTH},
    {"C1_POLLSN",  QDP_C1_POLLSN}, 
    {"C1_SPHY",    QDP_C1_SPHY},
    {"C1_RQPHY",   QDP_C1_RQPHY}, 
    {"C1_SLOG",    QDP_C1_SLOG},
    {"C1_RQLOG",   QDP_C1_RQLOG}, 
    {"C1_CTRL",    QDP_C1_CTRL},
    {"C1_SGLOB",   QDP_C1_SGLOB}, 
    {"C1_RQGLOB",  QDP_C1_RQGLOB},
    {"C1_RQFIX",   QDP_C1_RQFIX}, 
    {"C1_SMAN",    QDP_C1_SMAN},
    {"C1_RQMAN",   QDP_C1_RQMAN}, 
    {"C1_RQSTAT",  QDP_C1_RQSTAT},
    {"C1_WSTAT",   QDP_C1_WSTAT}, 
    {"C1_VCO",     QDP_C1_VCO},
    {"C1_PULSE",   QDP_C1_PULSE}, 
    {"C1_QCAL",    QDP_C1_QCAL},
    {"C1_STOP",    QDP_C1_STOP}, 
    {"C1_RQRT",    QDP_C1_RQRT},
    {"C1_MRT",     QDP_C1_MRT}, 
    {"C1_RQTHN",   QDP_C1_RQTHN},
    {"C1_RQGID",   QDP_C1_RQGID}, 
    {"C1_SCNP",    QDP_C1_SCNP},
    {"C1_SRTC",    QDP_C1_SRTC}, 
    {"C1_SOUT",    QDP_C1_SOUT},
    {"C1_SSPP",    QDP_C1_SSPP}, 
    {"C1_RQSPP",   QDP_C1_RQSPP},
    {"C1_SSC",     QDP_C1_SSC}, 
    {"C1_RQSC",    QDP_C1_RQSC},
    {"C1_UMSG",    QDP_C1_UMSG}, 
    {"C1_WEB",     QDP_C1_WEB},
    {"C1_RQFLGS",  QDP_C1_RQFLGS}, 
    {"C1_RQDCP",   QDP_C1_RQDCP},
    {"C1_RQDEV",   QDP_C1_RQDEV}, 
    {"C1_SDEV",    QDP_C1_SDEV},
    {"C1_PING",    QDP_C1_PING}, 
    {"C1_SMEM",    QDP_C1_SMEM},
    {"C1_RQMEM",   QDP_C1_RQMEM}, 
    {"C1_ERASE",   QDP_C1_ERASE},
    {"C1_RQMOD",   QDP_C1_RQMOD}, 
    {"C1_RQFREE",  QDP_C1_RQFREE},
    {"C2_SPHY",    QDP_C2_SPHY}, 
    {"C2_RQPHY",   QDP_C2_RQPHY},
    {"C2_SGPS",    QDP_C2_SGPS}, 
    {"C2_RQGPS",   QDP_C2_RQGPS},
    {"C2_SWIN",    QDP_C2_SWIN}, 
    {"C2_RQWIN",   QDP_C2_RQWIN},
    {"C2_SAMASS",  QDP_C2_SAMASS}, 
    {"C2_RQAMASS", QDP_C2_RQAMASS},
    {"C2_SBPWR",   QDP_C2_SBPWR}, 
    {"C2_BRDY",    QDP_C2_BRDY},
    {"C2_BOFF",    QDP_C2_BOFF}, 
    {"C2_BRESP",   QDP_C2_BRESP},
    {"C2_REGCHK",  QDP_C2_REGCHK}, 
    {"C2_INST",    QDP_C2_INST},
    {"C2_RQQV",    QDP_C2_RQQV}, 
    {"C2_RQMD5",   QDP_C2_RQMD5},
    {"C2_TERC",    QDP_C2_TERC}, 
    {"DT_DATA",    QDP_DT_DATA},
    {"DT_FILL",    QDP_DT_FILL}, 
    {"DT_USER",    QDP_DT_USER}, 
    {"DT_DACK",    QDP_DT_DACK},
    {"DT_OPEN",    QDP_DT_OPEN},
    {"SHUTDOWN",   QDP_SHUTDOWN},
    {NULL, 0}
};

static QDP_TEXT_MAP DetectorMap[] = {
    {"Murdock Hutt", QDP_TOKEN_TYPE_MHD}, 
    {"threshold",    QDP_TOKEN_TYPE_TDS}, 
    {NULL, 0}
};

static QDP_TEXT_MAP TercmdMap[] = {
    {"C3_ANNC",    QDP_C3_ANNC}, 
    {"C3_RQANNC",  QDP_C3_RQANNC},
    {"C3_SANNC",   QDP_C3_SANNC},
    {NULL, 0}
};

static QDP_TEXT_MAP ErrMap[] = {
    {"no error",                      QDP_CERR_NOERR},
    {"permission denied",             QDP_CERR_PERM},
    {"too many servers",              QDP_CERR_TMSERV},
    {"not registered",                QDP_CERR_NOTR},
    {"invalid registration response", QDP_CERR_INVREG},
    {"parameter error",               QDP_CERR_PAR},
    {"invalid EEPROM structure",      QDP_CERR_SNV},
    {"not on config port",            QDP_CERR_CTRL},
    {"not on special functions port", QDP_CERR_SPEC},
    {"memory operation in progress",  QDP_CERR_MEM},
    {"calibration in progress",       QDP_CERR_CIP},
    {"data not (yet) available",      QDP_CERR_DNA},
    {"not on console",                QDP_CERR_DB9},
    {"flash write/erase error",       QDP_CERR_FLASH},
    {NULL, 0}
};

static QDP_TEXT_MAP CtrlMap[] = {
    {"save",          QDP_CTRL_SAVE},
    {"reboot",        QDP_CTRL_REBOOT},
    {"resync",        QDP_CTRL_RESYNC},
    {"GPS On",        QDP_CTRL_GPS_ON},
    {"GPS Off",       QDP_CTRL_GPS_OFF},
    {"GPS Coldstart", QDP_CTRL_GPS_COLDSTART},
    {NULL, 0}
};

static QDP_TEXT_MAP PortMap[] = {
    {"configuration port",     QDP_CFG_PORT},
    {"special functions port", QDP_SFN_PORT},
    {"data port 1",            QDP_LOGICAL_PORT_1},
    {"data port 2",            QDP_LOGICAL_PORT_2},
    {"data port 3",            QDP_LOGICAL_PORT_3},
    {"data port 4",            QDP_LOGICAL_PORT_4},
    {NULL, 0}
};

static QDP_TEXT_MAP DataPortMap[] = {
    {"1", QDP_LOGICAL_PORT_1},
    {"2", QDP_LOGICAL_PORT_2},
    {"3", QDP_LOGICAL_PORT_3},
    {"4", QDP_LOGICAL_PORT_4},
    {NULL, 0}
};

static QDP_TEXT_MAP ErrcodeMap[] = {
    {"no error",         QDP_ERR_NO_ERROR},
    {"invalid argument", QDP_ERR_INVALID},
    {"no such item",     QDP_ERR_NOSUCH},
    {"no memory",        QDP_ERR_NOMEM},
    {"server busy",      QDP_ERR_BUSY},
    {"UDP I/O error",    QDP_ERR_UDPIO},
    {NULL, 0}
};

static QDP_TEXT_MAP DebugMap[] = {
    {"terse",  QDP_TERSE},
    {"normal", QDP_INFO},
    {"debug",  QDP_DEBUG},
    {NULL, 0}
};

static QDP_TEXT_MAP MemTypeMap[] = {
    {"Flash Memory",                         QDP_MEM_TYPE_FLASH},
    {"Configuration Memory for Data Port 1", QDP_MEM_TYPE_CONFIG_DP1},
    {"Configuration Memory for Data Port 2", QDP_MEM_TYPE_CONFIG_DP2},
    {"Configuration Memory for Data Port 3", QDP_MEM_TYPE_CONFIG_DP3},
    {"Configuration Memory for Data Port 4", QDP_MEM_TYPE_CONFIG_DP4},
    {"Web Page Memory",                      QDP_MEM_TYPE_WEBPAGE},
    {"Slave Processor EEPROM",               QDP_MEM_TYPE_SLAVE_EEPROM},
    {"Slave Processor PIC Internal Memory",  QDP_MEM_TYPE_SLAVE_PIC},
    {"Clock Chip RAM",                       QDP_MEM_TYPE_CLOCK_RAM},
    {"Calibrator PIC Internal Memory",       QDP_MEM_TYPE_CALIB_PIC},
    {"QAPCHP EEPROM",                        QDP_MEM_TYPE_QAPCHP_EEPROM},
    {"Packet Buffer Memory",                 QDP_MEM_TYPE_PKTBUF_MEM},
    {"DSP Program Memory",                   QDP_MEM_TYPE_DSP_PROG_MEM},
    {"DSP Data Memory",                      QDP_MEM_TYPE_DSP_DATA_MEM},
    {"*** INVALID ***",                      QDP_MEM_TYPE_INVALID},
    {NULL, 0}
};

static QDP_TEXT_MAP BlocketteIdentMap[] = {
    {"QDP_DC_ST38  ",    QDP_DC_ST38},
    {"QDP_DC_ST816 ",   QDP_DC_ST816},
    {"QDP_DC_ST32  ",    QDP_DC_ST32},
    {"QDP_DC_ST232 ",   QDP_DC_ST232},
    {"QDP_DC_MN38  ",    QDP_DC_MN38},
    {"QDP_DC_MN816 ",   QDP_DC_MN816},
    {"QDP_DC_MN32  ",    QDP_DC_MN32},
    {"QDP_DC_MN232 ",   QDP_DC_MN232},
    {"QDP_DC_AG38  ",    QDP_DC_AG38},
    {"QDP_DC_AG816 ",   QDP_DC_AG816},
    {"QDP_DC_AG32  ",    QDP_DC_AG32},
    {"QDP_DC_AG232 ",   QDP_DC_AG232},
    {"QDP_DC_CNP38 ",   QDP_DC_CNP38},
    {"QDP_DC_CNP816",  QDP_DC_CNP816},
    {"QDP_DC_CNP316",  QDP_DC_CNP316},
    {"QDP_DC_CNP232",  QDP_DC_CNP232},
    {"QDP_DC_D32   ",     QDP_DC_D32},
    {"QDP_DC_COMP  ",    QDP_DC_COMP},
    {"QDP_DC_MULT  ",    QDP_DC_MULT},
    {"QDP_DC_SPEC  ",    QDP_DC_SPEC},
    {NULL, 0}
};

static QDP_TEXT_MAP PLLStateMap[] = {
    {"off",      QDP_PLL_OFF},
    {"hold",     QDP_PLL_HOLD},
    {"tracking", QDP_PLL_TRACK},
    {"locked",   QDP_PLL_LOCK},
    {NULL, 0}
};

static QDP_TEXT_MAP PhysicalPortMap[] = {
    {"Serial 1", QDP_PP_SERIAL_1},
    {"Serial 2", QDP_PP_SERIAL_2},
    {"Serial 3", QDP_PP_SERIAL_3},
    {"Ethernet", QDP_PP_ETHERNET},
    {NULL, 0}
};

static QDP_TEXT_MAP SensorControlMap[] = {
    {"Idle",                 QDP_SC_IDLE},
    {"Sensor A Calibrate",   QDP_SC_SENSOR_A_CALIB},
    {"Sensor A Centering",   QDP_SC_SENSOR_A_CENTER},
    {"Sensor A Capacitive",  QDP_SC_SENSOR_A_CAP},
    {"Sensor B Calibrate",   QDP_SC_SENSOR_B_CALIB},
    {"Sensor B Centering",   QDP_SC_SENSOR_B_CENTER},
    {"Sensor B Capacitive",  QDP_SC_SENSOR_B_CAP},
    {"Sensor A Unlock",      QDP_SC_SENSOR_A_UNLOCK},
    {"Sensor A Lock",        QDP_SC_SENSOR_A_LOCK},
    {"Sensor A Auxiliary 1", QDP_SC_SENSOR_A_AUX1},
    {"Sensor A Auxiliary 2", QDP_SC_SENSOR_A_AUX2},
    {"Sensor B Unlock",      QDP_SC_SENSOR_B_UNLOCK},
    {"Sensor B Lock",        QDP_SC_SENSOR_B_LOCK},
    {"Sensor B Auxiliary 1", QDP_SC_SENSOR_B_AUX1},
    {"Sensor B Auxiliary 2", QDP_SC_SENSOR_B_AUX2},
    {NULL, 0}
};

static QDP_TEXT_MAP SensorControlMap2[] = {
    {"     -  ", QDP_SC_IDLE},
    {"A calib ", QDP_SC_SENSOR_A_CALIB},
    {"A center", QDP_SC_SENSOR_A_CENTER},
    {"A  cap  ", QDP_SC_SENSOR_A_CAP},
    {"B calib ", QDP_SC_SENSOR_B_CALIB},
    {"B center", QDP_SC_SENSOR_B_CENTER},
    {"B  cap  ", QDP_SC_SENSOR_B_CAP},
    {"A unlock", QDP_SC_SENSOR_A_UNLOCK},
    {"A  lock ", QDP_SC_SENSOR_A_LOCK},
    {"A  aux1 ", QDP_SC_SENSOR_A_AUX1},
    {"A  aux2 ", QDP_SC_SENSOR_A_AUX2},
    {"B unlock", QDP_SC_SENSOR_B_UNLOCK},
    {"B  lock ", QDP_SC_SENSOR_B_LOCK},
    {"B  aux1 ", QDP_SC_SENSOR_B_AUX1},
    {"B  aux2 ", QDP_SC_SENSOR_B_AUX2},
    {NULL, 0}
};

static QDP_TEXT_MAP AuxtypeMap[] = {
    {"AuxAD", QDP_AUXAD_DEFAULT},
    {NULL, 0}
};

static QDP_TEXT_MAP ClocktypeMap[] = {
    {"No clock", QDP_CLOCK_NONE},
    {"Motorola M12", QDP_CLOCK_M12},
    {NULL, 0}
};

static QDP_TEXT_MAP CalibratorMap[] = {
    {"QCAL330", QDP_CALIBRATOR_QCAL330},
    {NULL, 0}
};

static QDP_TEXT_MAP WebPageMap[] = QDP_WEB_PAGE_MAP;

static QDP_TEXT_MAP LogicalOperatorMap[] = {
    { "leftpar", QDP_CDS_EQ_LEFTPAR},
    {"rightpar", QDP_CDS_EQ_RIGHTPAR},
    {     "not", QDP_CDS_EQ_NOT},
    {     "and", QDP_CDS_EQ_AND},
    {      "or", QDP_CDS_EQ_OR},
    {     "eor", QDP_CDS_EQ_EOR},
    {    "done", QDP_CDS_EQ_DONE},
    {NULL, 0xff}
};

static QDP_TEXT_MAP SSPortMap[] = {
    { "serial port 1", 0 },
    { "serial port 2", 1 },
    {NULL, 0}
};

static QDP_TEXT_MAP SSTypeMap[] = {
    {     "absolute", QDP_SS_TYPE_ABSOLUTE     },
    {        "guage", QDP_SS_TYPE_GUAGE        },
    { "differential", QDP_SS_TYPE_DIFFERENTIAL },
    {NULL, 0}
};

static QDP_TEXT_MAP TokenTypeMap[] = {
    {                             "ignore", QDP_TOKEN_TYPE_IGNORE},
    {               "Token Version Number", QDP_TOKEN_TYPE_VER},
    {             "Network and Station ID", QDP_TOKEN_TYPE_SITE},
    {                       "DP Netserver", QDP_TOKEN_TYPE_NETSERVER},
    {                       "DP Webserver", QDP_TOKEN_TYPE_WEBSERVER},
    {                    "DataServer Port", QDP_TOKEN_TYPE_DATSERVER},
    {"Data Subscription Server Parameters", QDP_TOKEN_TYPE_DSS},
    {        "Clock Processing Parameters", QDP_TOKEN_TYPE_CLOCK},
    {      "Log and Timing Identification", QDP_TOKEN_TYPE_LOGID},
    {       "Configuration Identification", QDP_TOKEN_TYPE_CNFID},
    {              "Logical Channel Queue", QDP_TOKEN_TYPE_LCQ},
    {           "IIR Filter Specification", QDP_TOKEN_TYPE_IIR},
    {           "FIR Filter Specification", QDP_TOKEN_TYPE_FIR},
    {     "Control Detector Specification", QDP_TOKEN_TYPE_CDS},
    {"Murdock Hutt Detector Specification", QDP_TOKEN_TYPE_MHD},
    {   "Threshold Detector Specification", QDP_TOKEN_TYPE_TDS},
    {                   "Non-compliant DP", QDP_TOKEN_TYPE_NONCOMP},
    {                   "Comm Event Names", QDP_TOKEN_TYPE_CEN},
    {          "Email Alert Configuration", QDP_TOKEN_TYPE_EMAIL},
    {               "Opaque Configuration", QDP_TOKEN_TYPE_OPAQUE},
    {NULL, 0}
};

static QDP_TEXT_MAP SSUnitsMap[] = {
    {  "user", QDP_SS_UNITS_USER},
    {   "psi", QDP_SS_UNITS_PSI},
    {  "mbar", QDP_SS_UNITS_MBAR},
    {   "bar", QDP_SS_UNITS_BAR},
    {   "kPa", QDP_SS_UNITS_KPA},
    {   "MPa", QDP_SS_UNITS_MPA},
    { "in Hg", QDP_SS_UNITS_INHG},
    { "mm Hg", QDP_SS_UNITS_MMHG},
    { "m H20", QDP_SS_UNITS_MH2O},
    {NULL, 0}
};

static QDP_TEXT_MAP InputMuxMap[] = {
    {       "1pps", QDP_INPUT_MUX_1PPS},
    {  "reference", QDP_INPUT_MUX_REFERENCE},
    { "calibrator", QDP_INPUT_MUX_CALIBRATOR},
    {   "grounded", QDP_INPUT_MUX_GROUNDED},
    {NULL, 0}
};

static QDP_TEXT_MAP InputMuxMap2[] = {
    { "pps", QDP_INPUT_MUX_1PPS},
    { "ref", QDP_INPUT_MUX_REFERENCE},
    { "cal", QDP_INPUT_MUX_CALIBRATOR},
    { "gnd", QDP_INPUT_MUX_GROUNDED},
    {NULL, 0}
};

static char *LocateString(int code, QDP_TEXT_MAP *map, char *DefaultMessage)
{
int i;

    for (i = 0; map[i].text != NULL; i++) if (map[i].code == code) return map[i].text;
    return DefaultMessage;
}

static int LocateCode(char *string, QDP_TEXT_MAP *map, int DefaultCode)
{
int i;

    for (i = 0; map[i].text != NULL; i++) if (strcasecmp(map[i].text, string) == 0) return map[i].code;
    return DefaultCode;
}

char *qdpCmdString(UINT8 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, CmdMap, DefaultMessage);
}

char *qdpTercmdString(UINT8 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, TercmdMap, DefaultMessage);
}

int qdpCmdCode(char *string)
{
static int DefaultCode = QDP_CX_XXXX;

    return LocateCode(string, CmdMap, DefaultCode);
}

int qdpTercmdCode(char *string)
{
static int DefaultCode = 0xff;

    return LocateCode(string, TercmdMap, DefaultCode);
}

char *qdpErrString(UINT16 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, ErrMap, DefaultMessage);
}

char *qdpCtrlString(UINT8 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, CtrlMap, DefaultMessage);
}

char *qdpPortString(int code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, PortMap, DefaultMessage);
}

char *qdpDataPortString(int code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, DataPortMap, DefaultMessage);
}

char *qdpDebugString(UINT8 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, DebugMap, DefaultMessage);
}

char *qdpMemTypeString(UINT8 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, MemTypeMap, DefaultMessage);
}

char *qdpBlocketteIdentString(UINT8 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, BlocketteIdentMap, DefaultMessage);
}

char *qdpPLLStateString(UINT16 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString((UINT8) code, PLLStateMap, DefaultMessage);
}

char *qdpPhysicalPortString(UINT16 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString((UINT8) code, PhysicalPortMap, DefaultMessage);
}

char *qdpSensorControlString(UINT32 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString((UINT8) (code & QDP_SC_MASK), SensorControlMap, DefaultMessage);
}

char *qdpSensorControlString2(UINT32 code)
{
static char *DefaultMessage = "? ? ? ? ";

    return LocateString((UINT8) (code & QDP_SC_MASK), SensorControlMap2, DefaultMessage);
}

char *qdpAuxtypeString(UINT16 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, AuxtypeMap, DefaultMessage);
}

char *qdpClocktypeString(UINT16 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, ClocktypeMap, DefaultMessage);
}

char *qdpDetectorString(UINT16 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, DetectorMap, DefaultMessage);
}

char *qdpCalibratorString(UINT16 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, CalibratorMap, DefaultMessage);
}

char *qdpWebPageMacro(UINT8 code)
{
static char *DefaultMessage = NULL;

    return LocateString(code, WebPageMap, DefaultMessage);
}

char *qdpLogicalOperatorString(UINT8 code)
{
static char *DefaultMessage = NULL;

    return LocateString(code, LogicalOperatorMap, DefaultMessage);
}

int qdpLogicalOperatorCode(char *string)
{
static int DefaultCode = 0xff;

    return LocateCode(string, LogicalOperatorMap, DefaultCode);
}

char *qdpSSPortString(UINT16 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, SSPortMap, DefaultMessage);
}

char *qdpSSTypeString(UINT16 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, SSTypeMap, DefaultMessage);
}

char *qdpSSUnitsString(UINT16 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, SSUnitsMap, DefaultMessage);
}

char *qdpTokenTypeString(UINT8 code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, TokenTypeMap, DefaultMessage);
}

char *qdpErrcodeString(int code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, ErrcodeMap, DefaultMessage);
}

char *qdpInputMuxString(int code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, InputMuxMap, DefaultMessage);
}

char *qdpInputMuxString2(int code)
{
static char *DefaultMessage = "<unknown>";

    return LocateString(code, InputMuxMap2, DefaultMessage);
}

int qdpInputMuxCode(char *string)
{
static int DefaultCode = QDP_INPUT_MUX_UNDEFINED;

    return LocateCode(string, InputMuxMap2, DefaultCode);
}

char *qdpInputBitmapString(UINT16 bitmap, char *buf)
{
int chan, shift;
static char mt_unsafe[] = "1=calibrator 2=calibrator 3=calibrator 4=calibrator 5=calibrator 6=calibrator + slop";

    if (buf == NULL) buf = mt_unsafe;
    buf[0] = 0;

    for (chan = 1, shift=0; chan <= 3; chan++, shift++) {
        sprintf(buf+strlen(buf), "%d=", chan);
        if (bitmap & (1 << shift)) {
            sprintf(buf+strlen(buf), "%-10s ", qdpInputMuxString(qdpInputMuxA(bitmap)));
        } else {
            sprintf(buf+strlen(buf), "%-10s ", "normal");
        }
    }
    for (chan = 4, shift=3; chan <= 6; chan++, shift++) {
        sprintf(buf+strlen(buf), "%d=", chan);
        if (bitmap & (1 << shift)) {
            sprintf(buf+strlen(buf), "%-10s ", qdpInputMuxString(qdpInputMuxB(bitmap)));
        } else {
            sprintf(buf+strlen(buf), "%-10s ", "normal");
        }
    }
    return buf;
}

/*-----------------------------------------------------------------------+
 |                                                                       |
 | Copyright (C) 2006 Regents of the University of California            |
 |                                                                       |
 | This software is provided 'as-is', without any express or implied     |
 | warranty.  In no event will the authors be held liable for any        |
 | damages arising from the use of this software.                        |
 |                                                                       |
 | Permission is granted to anyone to use this software for any purpose, |
 | including commercial applications, and to alter it and redistribute   |
 | it freely, subject to the following restrictions:                     |
 |                                                                       |
 | 1. The origin of this software must not be misrepresented; you must   |
 |    not claim that you wrote the original software. If you use this    |
 |    software in a product, an acknowledgment in the product            |
 |    documentation of the contribution by Project IDA, UCSD would be    |
 |    appreciated but is not required.                                   |
 | 2. Altered source versions must be plainly marked as such, and must   |
 |    not be misrepresented as being the original software.              |
 | 3. This notice may not be removed or altered from any source          |
 |    distribution.                                                      |
 |                                                                       |
 +-----------------------------------------------------------------------*/

/* Revision History
 *
 * $Log: string.c,v $
 * Revision 1.26  2012/01/17 18:44:47  dechavez
 * added qdpDataPortString()
 *
 * Revision 1.25  2011/02/14 16:50:36  dechavez
 * fixed toggled locked/unlocked message errors for Sensor A control
 *
 * Revision 1.24  2011/01/03 21:25:59  dechavez
 * added qdpInputBitmapString(), qdpInputMuxCode(), qdpInputMuxString2()
 *
 * Revision 1.23  2010/10/19 21:12:49  dechavez
 * added qdpSensorControlString2()
 *
 * Revision 1.22  2010/04/07 19:48:57  dechavez
 * added qdpInputMuxString()
 *
 * Revision 1.21  2010/04/02 18:19:51  dechavez
 * qdpErrcodeString() support for QDP_ERR_UDPIO
 *
 * Revision 1.20  2010/03/31 20:26:25  dechavez
 * added QDP_SHUTDOWN to CmdMap
 *
 * Revision 1.19  2010/03/22 21:34:25  dechavez
 * added qdpErrcodeString(), made all PortMap[] text lowercase
 *
 * Revision 1.18  2009/11/05 18:31:26  dechavez
 * added qdpTokenTypeString()
 *
 * Revision 1.17  2009/10/29 17:27:27  dechavez
 * use QDP_TEXT_MAP from qdp/codes.h instead of local TEXT_MAP type, also QDP_WEB_PAGE_MAP from codes.h
 *
 * Revision 1.16  2009/10/20 22:37:58  dechavez
 * qdpLogicalOperatorCode(), qdpSSPortString(), qdpSSTypeString(), qdpSSUnitsString()
 *
 * Revision 1.15  2009/10/02 18:37:53  dechavez
 * added qdpWebPageMacro(), qdpLogicalOperatorString()
 *
 * Revision 1.14  2009/09/28 17:38:06  dechavez
 * added qdpDetectorString(), qdpTercmdCode(), qdpCmdCode(), qdpTercmdString()
 *
 * Revision 1.13  2009/02/03 23:01:04  dechavez
 * dded qdpAuxtypeString(), qdpClocktypeString(), qdpCalibratorString()
 *
 * Revision 1.12  2009/01/24 00:11:08  dechavez
 * added qdpSensorControlString(), fixed C1_GLOB typo
 *
 * Revision 1.11  2007/12/21 18:54:26  dechavez
 * Fixed PhysicalPortMap entries
 *
 * Revision 1.10  2007/12/20 22:49:14  dechavez
 * added qdpPLLStateString(), qdpPhysicalPortString()
 *
 * Revision 1.9  2007/05/18 18:00:57  dechavez
 * initial production release
 *
 */
