#pragma ident "$Id: version.c,v 1.81 2013/02/07 18:19:01 dechavez Exp $"
/*======================================================================
 * 
 * library version management
 *
 *====================================================================*/
#include "qdp.h"

static VERSION version = {3, 6, 0};
char *libqdpBuildIdent = "libqdp release 3.6.0, compiled " __DATE__ " " __TIME__;

/* qdp library release notes

3.6.0   02/07/2013
        hlp.c: toss the 1-sec overlaps that follow reconnects (this addresses the
               short packet followed by overlap mess that comes with bad comm links)

3.5.0   02/05/2013
        qdp/status.h: added percent field to QDP_STAT_DPORT
        status.c: added QDP_STAT_DPORT percent support to DecodeDPORT() and PrintDPORT()

3.4.1   08/07/2012
        hlp.c: fixed qdpDestroyHLP() declaration (removed extraneous *)

3.4.0   06/24/2012 Bound C1_LOG and tokens together with QDP_TYPE_DPORT
        qdp.h: replaced QDP_TYPE_FULL_CONFIG log and token fields with dport,
            added misc.c prototypes
		qdp/tokens.h: renamed QDP_TOKEN_LCQ sint to dsint, added nsint
        cmds.c: added port value to qdpEncode_C1_LOG() in qdpFlushDataPort()
        config.c: introduce qdpRequestDportConfig() and qdpConfigureDataPort(), also
          major cleanup of qdpSetConfig() to use qdpConfigureDataPort()
        decode.c: qdpDecode_C1_LOG() leaves decoded port number 0-based
        encode.c: qdpEncode_C1_LOG() packs port number using supplied argument, ignoring C1_LOG field
        meta.c: use qdpMainDigitizerChanNum() to compute chan from src[0]
        misc.c: introduce qdpConvertSampleRate(), qdpMainDigitizerChanNum(), qdpUpdateDataPortChannelFreqs()
        print.c:  lcq sint renamed to dsint
        status.c: PrintDPORT() uses qdpDataPortString() for data port identifier
        tokens.c: UnpackTokenLcq() sets derived fields with qdpConvertSampleRate()
        webpage.c: config->dport[i].token instead of config->token[i]


3.3.0   01/17/2012
        qdp.h: added qdpDataPortString() prototype
        qdp/status.h: added clock_perc to QDP_STAT_GBL
        status.c: added prefixes to make all "Input Voltage" strings unique,
           compute and print clock quality percentage instead of bitmap
        string.c: added qdpDataPortString()

3.2.1   02/14/2011
        string.c: fixed toggled locked/unlocked message errors for Sensor A control

3.2.0   02/07/2011 fixed state machine restart
        fsa.h: added QDP_EVENT_DOWN, invoke QDP_ACTION_TLD in all cases
        qdp.h: removed unused qdpClose() prototype
        fsa.c: qdpStartFSA() brings down machine if registration fails,
           while last instance of TerminateSelf() closes all sockets
        io.c: removed qdpClose()

3.1.0   02/01/2011
        config.c: qdpSetConfig() to accept caller imposed override of ethernet IP
        fsa.c: fixed bug preventing delivery of C1_MYSN and C1_PHY after registration

3.0.0   01/31/2011 Q330 console support
        qdp.h: defined QDP_BROADCAST_IP and QDP_BROADCAST_PORT
        fsa.h: added support for determining serial IP address
        action.c: added ActionRQPHY() and ActionLDPHY() event handlers
        fsa: added support for determining console port IP address
        init.c: set destination IP to broadcast when not using network I/O
        io.c: when ip is broadcast address, override qdpSendPkt() destination port with broadcast port

2.4.4   01/25/2011 (checkpoint on the way to adding Q330 console support)
        qdp.h: eliminated QDPIO in favor of QIO (from new libqio), introduced QDP_CONNECT
        init.c: replaced InitIO with InitConnections(), and use QDP_CONNECT "connect"
        io.c: switched to libqio calls instead of local qdpioX
        par.c: added qdpInitConnect(), qdpSetConnect(), removed qdpSetIdent()
        qdpio.c: removed (functionality move to libqio)

2.4.3   01/13/2011 (checkpoint on the way to adding Q330 console support)
        qdp.h: changed name of QDP_PAR "host" field to more generic "input"
               added macros for checking serial number and inferring console
        action.c: update peer ident with serial number in ActionSAVESN()
        connect.c: removed old qdpConnect() and gave name to qdpConnectWithPar()
        init.c: added InitIO to handle the details of I/O set up and to hide
               knowledge about console connection or not
        par.c: par "host" to "ident", qdpSetHost() to qdpSetIdent()
        tokens.c: changed name of qdpSetIdent() to qdpSetTokenIdent()

2.4.2   01/13/2011 (checkpoint on the way to adding Q330 console support)
        qdp.h: added QDP_TYPE_C1_MYSN
        fsa.h: added support for polling digitizer for serial number
        action.c: added ActionPOLLSN() and ActionSAVESN()
        decode.c: added qdpDecode_C1_MYSN() (untested)
        fsa.c: added QDP_EVENT_MYSN, QDP_ACTION_POLLSN, and QDP_ACTION_SAVESN support
        init.c: initial state for UDP connections changed to QDP_STATE_UNREG

2.4.1   01/12/2011 (checkpoint on the way to adding Q330 console support)
        qdp.h: added qdpEncode_C1_POLLSN prototype
        encode.c: added qdpEncode_C1_POLLSN()
        qdpio.c: changes associated with evolving slpio routines... not yet tested

2.4.0   01/11/2011 (checkpoint on the way to adding Q330 console support)
        I/O data structures generalized to support both UDP and SLIP.  BUT, still
        no way to actually specify a SLIP connection.  This is a checkpoint only
        commit to preserve UDP I/O under the new data structures.
        qdp.h: introduced QDPIO
        init.c: all libudpio structures and library calls changed to qdpio
          equivalents, but no support for anything other than UDP yet provided.
        io.c: all libudpio structures and library calls changed to qdpio equivalents
        qdpio.c: created

2.3.6   01/07/2011
        qdp.h: added QDP_DEFAULT_C1_SPP

2.3.5   01/03/2011
        qdp.h: added QDP_TYPE_C1_GLOB glob to QDP_TYPE_MONITOR
        pkts.c: added qdp_C1_RQGLOB to qdpRequestMonitor()
        print.c: changed qdpPrintInputBitmap() to use qdpInputBitmapString()
        string.c: added qdpInputBitmapString(), qdpInputMuxCode(), qdpInputMuxString2()

2.3.4   12/23/2010
        action.c: fixed HORRIBLE off by one bug in ActionRQCNF call to qdpEncode_C1_RQFLGS() port parameter
        cmds.c: use only symbolic values for port numbers in qdpFlushDataPort()
        config.c: replaced QDP_NUM_LOGICAL_PORTS with QDP_NLP, replaced explicit
          numerical indices in config->log and config->token with symbolic values
        par.c: added qdpValidPort()

2.3.3   12/22/2010
        qdp.h: cleaned up port numbering some more, defined QDP_NUM_LOGICAL_PORTS
        config.c: use explicit symbolic port numbers when requesting data port config
        par.c: added qdpDataPortNumber()

2.3.2   12/13/2010
        qdp.h: renumbered the port number defines so they could be used as array indicies
        qdp/code.h: changed QDP_SC_SENSOR_UNDEFINED to more appropriate QDP_SC_UNDEFINED

2.3.1   12/13/2010
        qdp.h: removed scMisMatch from QDP_TYPE_MONITOR
        qdp/codes.h: added QDP_SC_SENSOR_UNDEFINED

2.3.0   11/15/2010
        cmds.c: added qdpFlushDataPort()

2.2.3   11/02/2010
        status.c: fixed unpack error in DecodeUMSG() that was causing qdpDecode_C1_STAT()
          to seg fault when present

2.2.2   10/20/2010
        qdp.h: added QDP_DEFAULT_TOKEN_CLOCK
        par.c: added qdpAddOption(), removed unused arg arg from qdpSetOptionFlags()
        pkts.c: added QDP_SRB_SS to status request bitmap in qdpRequestMonitor()

2.2.1   10/19/2010
        string.c: added qdpSensorControlString2()

2.2.0   04/07/2010
        qdp/codes.h: added QDP_INPUT_MUX_x stuff
        print.c: added qdpPrintInputBitmap()
        strings.c: added qdpInputMuxString()

2.1.0   04/02/2010
        qdp/errno.h: added QDP_ERR_UDPIO
        init.c: set return ports to port.ctrl.value, port.data.value, set errcode to
            QDP_ERR_UDPIO in the event of udpioInit() failures
        par.c: restored qdpSetMyCtrlPort() and qdpSetMyDataPort().  Changed default
            vaues for port.ctrl.value and port.data.value to 0 to still permit OS
            assigned return ports.
        string.c: qdpErrcodeString() support for QDP_ERR_UDPIO

2.0.0   03/31/2010
        qdp.h: added QDP_SHUTDOWN, removed trash link parameters
        cmds.c: added qdpShutdown()
        connect.c: moved qdpLogPar to before qdpInit
        data.c: added conditional (ENABLE_DEBUG_BLOCKETTES) blockkette dumps
        fsa.c: changed qdpState() to qdpFsaState(), added QDP_SHUTDOWN support, removed link trasher
        hlp.c: added qdpFlushLCQ()
        init.c: get OS assigned return port numbers in udioInit() (finally!)
        io.c: removed trash link options, added call to qdpShutdown() in qdpClose()
        msgq.c: changed qdpState() call to qdpFsaState()
        par.c: removed trash link parameters and functions, removed unused
            qdpParseArgString(), qdpSetMyCtrlPort() and qdpSetMyDataPort() functions,
            changed qdpLogPar() and qdpPrintPar() to take QDP_PAR as the argument
        string.c: added QDP_SHUTDOWN to CmdMap

1.11.0  03/22/2010
        qdp.h: added options flag to QDP_PAR (default QDP_PAR_OPTION_QUITBUSY)
        action.c: added ActionBUSY
        connect.c: added errcode arg to qdpConnect(), qdpConnectWithPar()
        data.c: added qdpLenBT_COMP(), qdpLenBT_SPEC(), qdpHaveCalNotifyBlockette()
        fsa.c: added QDP_ACTION_BUSY branch, terminate registration if busy and QDP_PAR_OPTION_QUITBUSY set
        io.c: added qdpClose()
        par.c: added qdpSetOptionFlags(), defined options flag in qdpInitPar()
        string.c: added qdpErrcodeString(), made all PortMap[] text lowercase

1.10.0  03/11/2010
       hlp.c: added LCQ src bytes to QDP_HLP
       ida10.c: added LCQ src bytes to IDA10.4 header

1.9.4   11/14/2009
        qdp.h: added C1_CERR err cmd sub-field to QDP handle
        action.c: use C1_CERR err field in handle to communicate errors back to application (eg, memory busy)
        cmd.c: added qdpMemCmd() (for memory busy retries)
        config.c: changed commentary, added new qdpPostMemBlk() args (for memory busy retries)
        mem.c: fixed initialization bug in qdpSaveMem() introduced in 1.9.3, cleaned up and fixed qdpPostMemBlk()
        pkts.c: use qdpMemCmd() instead of qdpPostCmd() in qdp_C1_RQMEM (for memory busy retries)
        process.c: backed out resid=2 change in ProcessMN38 (release 1.9.2)

1.9.3   11/05/2009 (checkpoint)
        qdp/tokens.h: added names for token types 193 and 194 (but no code)
        qdp.h: added new prototypes
        config.c: added qdpSetConfig() (webpage not implemented yet... gets error response from Q330)
        init.c: new type argument for qdpInitMemBlk()
        mem.c: implemented qdpPostMemBlk()
        pkts.c: new type argument for qdpInitMemBlk()
        print.c: removed clock processing parameters from qdpPrintTokenReport()
        process.c: new type argument for qdpInitMemBlk()
        pt.c: implemented qdpPackTokenMemblk()
        string.c: added qdpTokenTypeString()
        webpage.c: in qdpPackWebpageMemblk() set missing type, allow for NULL set names

1.9.2   10/29/2009
        config.c: removed qdpRequestWebpage() (moved to webpage.c)
        data.c: decode C1_FIX, C1_GLOB, and config SSCFG in BT_SPEC blockettes
        encode.c: added qdpEncode_C1_LOG(), qdpEncode_C2_AMASS(), qdpEncode_C2_PHY(), qdpEncode_C3_ANNC()
        init.c: initialize QDP dbgpkt
        pkts.c: use dbgpkt if available in qdp_C1_RQGLOB(), qdp_C1_RQSC(), qdp_C1_RQPHY(),
            qdp_C1_RQLOG(), qdp_C1_RQSPP(), qdp_C2_RQAMASS(), qdp_C2_RQPHY, qdp_C3_RQANNC()
        print.c: print decoded configuration blockettes in qdpPrintBT_SPEC(),
           cleaned up detect formatting in qdpPrintTokenLcq
        process.c: instead of ignoring resid=2 for in ProcessMN38, assume 0.1 sec sint,
           use flags instead of obsolete reqtoken rule in InitLC 
        pt.c: initial release
        string.c: use QDP_TEXT_MAP from qdp/codes.h instead of local TEXT_MAP type, also QDP_WEB_PAGE_MAP from codes.h
        tokens.c: added QDP_TOKEN_TYPE_NONCOMP support, use QDP_DSS_PASSWD_LEN
          instead of hardcoded number in decoding dss password fields
        webpage.c: initial release

1.9.1   10/20/2009
        status.c: fixed bug initializing serial sensor status

1.9.0   10/20/2009
        config.c: better qdpInitConfig()
        data.c: use QDP_CFG_x macros when ignoring (for now) the special packet config change blockettes
        decode.c: qdpDecode_SSCFG() (not yet tested)
        print.c: qdpBaudCode(), qdpPrintTokenCds(), qdpPrint_SSCFG(), use QDP_CFG_x in qdpPrintBT_SPEC()
        process: recognize QDP_SP_ENVDAT (sets QDP_LCQ_EVENT_ENVDAT)
        status.c: serial sensor status support
        string.c: qdpLogicalOperatorCode(), qdpSSPortString(), qdpSSTypeString(), qdpSSUnitsString()
        token.c: qdpInitIdent(), qdpSetIdent(), qdpInitTokenDet(), qdpInitLcq(),
            qdpInitTokens(), qdpFirFilterCode(), qdpLcqCode(), qdpLcqName(), qdpIirFilterCode(),
            qdpControlDetectorCode(), qdpEventDetectorCode(), qdpCommEventCode(), qdpLcqName(),
            qdpControlDetectorFilterName(), qdpSetLcqIdentName(), qdpFinalizeToken()

1.8.2   10/08/2009
        config.c: added support for set bitmask
        xml.c: moved off to libqdpxml

1.8.1   10/02/2009
        qdp/fsa.h: fixed the behavior in response to server busy during registration
        config.c: initial release
        decode.c: added web page support to qdpDecode_C1_MEM()
        mem.c: use QDP_MAX_C1_MEM_SEGLEN in place of former QDP_MAX_C1_MEM_CFGDATA
        pkts.c: moved qdpRequestFullConfig() to config.c
        print.c: added qdpBaud()
        string.c: added qdpWebPageMacro(), qdpLogicalOperatorString()
        tokens.c: added qdpControlDetectorString() and fixed comfr and pebuf defaults to agree with XML
        xml.c: initial release

1.8.0   09/28/2009
        qdp/codes.h: fixed QDP_C2_TERR, added QDP_C2_SNAPT, QDP_C3_ANNC and QDP_CX_XXXX
        qdp/tokens.h: gave QDP_TOKEN_TYPE_x names to the various token identifiers
            combined mdh and tds fields into a generic detector det field, added cen
        qdp.h: completed C2_PHY definition, updated QDP_TYPE_FULL_CONFIG, prototypes
        decode.c: completed qdpDecode_C2_PHY(), added qdpDecode_C3_ANNC()
        pkts.c: added qdpRequestTokens(), qdp_C3_RQANNC(), updated qdpRequestFullConfig()
        print.c: added support for det field, changed output ordering to more closely follow Willard ordering.
        stringc.c: added qdpDetectorString(), qdpTercmdCode(), qdpCmdCode(), qdpTercmdString()
        tokens.c: support for det, cen, added qdpLcqName(), qdpCommEventName(), qdpEventDetectorName(),
            qdpControlDetectorName(), qdpIirFilterName(), qdpFirFilterName()

1.7.4   09/22/2009
        decode.c: checkpoint (qdpDecode_C2_PHY)
        encode.c: added qdpEncode_C1_RQLOG(), qdpEncode_C2_RQPHY()
        pkts.c: added qdp_C1_RQLOG(), qdp_C2_RQPHY(), qdpRequestFullConfig()

1.7.3   09/14/2009
        pkts.c: added qdp_C1_RQMEM()
        print.c: added qdpPrintTokenChannelMap(), qdpPrintTokenReport(), changed
           format of qdpPrintTokenClock() output to make it more understandable

1.7.2   09/04/2009
        status.c: fixed bug in qdpGpsDateTimeToEpoch() sanity checks

1.7.1   07/13/2009
        status.c: sanity checks on qdpGpsDateTimeToEpoch() input

1.7.0   07/09/2009
        data.c: added code to load contents of QDP_BLOCKETTE_SPEC
        hlp.c:  added cal_in_progress flag
        print.c: introduced qdpPrintBlockettes(), added support for new
           QDP_BLOCKETTE_SPEC fields in qdpPrintBT_SPEC
        process.c: set special packet events in ProcessSPEC, changed logic in
           qdpProcessPacket() so that all blockettes get run through the
           processor even if we lack full meta data (those processors which
           require meta data just return immediately).
        status.c: added support for new tstamp fields in global and gps status

1.6.1   07/02/2009
        qdp.h: changed automatic status poll interval to 30 seconds
        status.c: added qdpCalibrationInProgress()

1.6.0   07/02/2009
        pkts.c: added qdpReadPktgz()

1.5.4   07/02/2009
        io.c: explicitly set errno to zero on normal qdpRead() returns

1.5.3   06/19/2009
        steim.c: fixed nasty B01 little-endian byte order bug, 
            deleted the dead code that had been #ifdef'd out in release 1.1.1

1.5.2   03/17/2009
        fsa.c: THREAD_DETACH all threads
        version.c: added libqdpBuildIdent

1.5.1   02/23/2009
        encode.c: added qdpEncode_C1_SPP(), qdpEncode_C2_GPS()
        print.c: print all fields int qdpPrint_C2_GPS() and added new funcs
            qdpPrint_CMNHDR(), qdpPrintLCQ(), qdpPrintPkt()

1.5.0   02/03/2009
        decode.c: added qdpDecode_C2_GPS(), qdpDecode_C1_DCP(), qdpDecode_C1_MAN(),
            qdpDecode_C1_SPP(), qdpDecode_C1_GID()
        pkts.c: added qdpRequestCheckout(), qdp_C1_RQSTAT(), qdp_C2_RQGPS(),
            qdp_C1_RQMAN, qdp_C1_RQSPP(), qdp_C1_RQDCP(), qdp_C1_RQGID(),
            qdp_C1_RQFIX(), qdp_C1_RQPHY(), qdp_C1_RQSC(), qdp_C1_RQGLOB()
        print.c: added qdpPrintCheckoutPackets(), qdpPrint_C2_GPS(), qdpPrint_C1_MAN(),
            qdpPrint_C1_SPP(), qdpPrint_C1_DCPMAN(), qdpPrint_C1_DCP(), qdpPrint_C1_GID()
            and added underlines to section headers
        process.c: log ProcessBlockette() error returns
        status.c: fixed up QDP_BOOM report
        string.c: added qdpAuxtypeString(), qdpClocktypeString(), qdpCalibratorString()

1.4.0   01/23/2009
        decode.c: fixed typo with qpdDecode_C1_FIX() name, added
            qdpDecode_C1_SC(), qdpDecode_C2_AMASS()
        encode.c: added qdpEncode_C1_PULSE(), qdpEncode_C1_SC(), qdpEncode_C1_GLOB()
        print.c: added qdpPrint_C1_SC(), qdpPrint_C2_AMASS_SENSOR(), qdpPrint_C2_AMASS()
        string.c: added qdpSensorControlString(), fixed C1_GLOB typo

1.3.2   01/06/2009
        encode.c: added qdpEncode_C1_PHY()

1.3.1   12/09/2008
        reorder.c: made "out of window" messages debug comments instead of warnings

1.3.0   10/02/2008.3.0   10/02/2008
        cmds.c: added qdpNoParCmd, qdpRqstat
        decode.c: added qdpDecode_C1_PHY
        encode.c: added qdpEncode_NoParCmd
        init.c: used QDP_STATUS_DATA_PORT_x instead of QDP_LOGICAL_PORT_x_STATUS
        print.c: added qdpPrint_C1_PHY
        process.c: removed unused dlen parameter from call to qdpDecode_C1_STAT
        status.c: removed unused dlen parameter from qdpDecode_C1_STAT,
            moved GSV report to under GPS in qdpPrint_C1_STAT.

1.2.0   03/05/2008
        process.c: added support for CNP316 (aux packets)

1.1.1   01/07/2008 *** First version tested on little-endian platform ***
        data.c: little-endian bug fixes
        ida10.c: little-endian bug fixes
        print.c: adding missing argument to detect[] string in qdpPrintTokenLcq
        steim.c: #ifdef'd out some dead code

1.1.0   12/20/2007
        qdp/limits.h: created
        qdp/status.h: created
        qdp.h: moved various limits to new qdp/limits.h, added support for
               C1_STAT, defined physical ports
        proocess.c: added support for C1_STAT
        status.c: created
        string.c: added qdpPLLStateString(), qdpPhysicalPortString()

1.0.5   12/14/2007
        qdp/lcq.h: changed blockette datum types from unsigned to signed

1.0.4   10/31/2007
        encode.c: added qdpEncode_C1_QCAL()
        init.c: replaced sprintf with snprintf
        md5.c: replaced sprintf with snprintf
        stats.c: added buffer length to utilTimeString() calls

1.0.3   09/06/2007
        init.c: include port number in udpioInit failure messages

1.0.2   06/26/2007
        steim.c: fixed dnib 01 (4 8-bit differences) bug

1.0.1   06/14/2007
        hlp.c: flush partial packets
        ida10.c: generate fixed-length 1024 byte packets

1.0.0   05/18/2007
        Initial production release
  
 */

char *qdpVersionString()
{
static char string[] = "qdp library version 100.100.100 and slop";

    snprintf(string, strlen(string), "qdp library version %d.%d.%d",
        version.major, version.minor, version.patch
    );

    return string;
}

VERSION *qdpVersion()
{
    return &version;
}
