#pragma ident "$Id: misc.c,v 1.1 2012/04/25 21:04:13 dechavez Exp $"
/*======================================================================
 *
 *  Convenience functions
 *
 *====================================================================*/
#include "tristar.h"

BOOL tristarParseServer(char *string, char **pserver, int *pport)
{
char *server;
#define MAXTOKEN 2
char *token[MAXTOKEN];
int ntoken, port = MODBUS_TCP_DEFAULT_PORT;

    ntoken = utilParse(string, token, ":", MAXTOKEN, 0);
    if (ntoken < 1) {
        fprintf(stderr, "error parsing server string '%s'\n", string);
        return FALSE;
    }

    if (ntoken >= 1) {
        if ((server = strdup(token[0])) == NULL) {
            perror("strdup");
            return FALSE;
        }
    }

    if (ntoken >= 2) {
        if ((port = atoi(token[1])) <= 0) {
            fprintf(stderr, "illegal port token '%s'\n", token[1]);
            return FALSE;
        }
    }

    *pserver = server;
    *pport = port;

    return TRUE;
}

/*-----------------------------------------------------------------------+
 |                                                                       |
 | Copyright (C) 2012 Regents of the University of California            |
 |                                                                       |
 | This software is provided 'as-is', without any express or implied     |
 | warranty.  In no event will the authors be held liable for any        |
 | damages arising from the use of this software.                        |
 |                                                                       |
 | Permission is granted to anyone to use this software for any purpose, |
 | including commercial applications, and to alter it and redistribute   |
 | it freely, subject to the following restrictions:                     |
 |                                                                       |
 | 1. The origin of this software must not be misrepresented; you must   |
 |    not claim that you wrote the original software. If you use this    |
 |    software in a product, an acknowledgment in the product            |
 |    documentation of the contribution by Project IDA, UCSD would be    |
 |    appreciated but is not required.                                   |
 | 2. Altered source versions must be plainly marked as such, and must   |
 |    not be misrepresented as being the original software.              |
 | 3. This notice may not be removed or altered from any source          |
 |    distribution.                                                      |
 |                                                                       |
 +-----------------------------------------------------------------------*/

/* Revision History
 *
 * $Log: misc.c,v $
 * Revision 1.1  2012/04/25 21:04:13  dechavez
 * initial release
 *
 */
