#include <windows.h>
#include <stdio.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <direct.h>
#include <fcntl.h>
#include <io.h>
#include <stdio.h>
#include "win32/zlib.h"

int mycompress(unsigned char *dst, unsigned long *destLen, unsigned char *src, unsigned long srcLen)
	{
	int err; 
	z_stream d_stream;

	memset(&d_stream, 0, sizeof(d_stream));
	d_stream.zalloc = (alloc_func)0;
    d_stream.zfree = (free_func)0;
    d_stream.opaque = (voidpf)0;

    d_stream.next_in  = src;
    d_stream.avail_in = srcLen;
    d_stream.next_out = dst; 
	d_stream.avail_out = *destLen;

	err = deflateInit2(&d_stream, Z_BEST_COMPRESSION , Z_DEFLATED, 31,  8, Z_DEFAULT_STRATEGY); 
    err = deflate(&d_stream, Z_SYNC_FLUSH);

	if(err != Z_OK)
		{
		return -1;
		}


	for (;;) {
        d_stream.avail_out = 1;
        err = deflate(&d_stream, Z_FINISH);
        if (err == Z_STREAM_END) break;
		if(err!=Z_OK) break;
    }



	if(err != Z_STREAM_END)
		{
		return -1;
		}
    err = deflateEnd(&d_stream); 
	if(err!=Z_OK)
		{
//		printf("File %s compress error", fname);
		return -1;
		}
//	FILE *f = fopen("c:\\11\\test.gz","wb");
//	if(f!=NULL)
//		{
//		DWORD dwSize = srcLen;
//		fwrite(hd, 10, 1, f);
//		memcpy(&dst[d_stream.total_out], &dwSize, 4);
//		fwrite(dst, d_stream.total_out, 1, f);
//		fclose(f);
//		}

//	gzFile gzf = gzopen("c:\\11\\gztest.gz","wb");
//	if(f!=NULL)
//		{
//		DWORD dwSize = srcLen;
//		gzwrite(gzf, src, srcLen);
//		gzclose(gzf);
//		}


	*destLen = d_stream.total_out;
	return Z_OK;
	}

int myuncompress(unsigned char *dst, unsigned long *destLen, unsigned char *src, unsigned long srcLen)
	{
	unsigned long src_len=0, dest_len=0;
	int err; 
	z_stream d_stream;

	memset(&d_stream, 0, sizeof(d_stream));

	d_stream.zalloc = (alloc_func)0;
    d_stream.zfree = (free_func)0;
    d_stream.opaque = (voidpf)0;

    d_stream.next_in  = src;
    d_stream.avail_in = srcLen;
    d_stream.next_out = dst; 
	d_stream.avail_out = *destLen;

	while(1)
		{
		err = inflateInit2(&d_stream, 47); 

		if(err < Z_OK)
			{
			inflateEnd(&d_stream);
			if(dest_len==0)
				{
				*destLen = dest_len;
				return -1;
				}
			else
				{
				*destLen = dest_len;
				return 0;
				}
			
			}

		err = inflate(&d_stream, Z_NO_FLUSH);

		if (err == Z_STREAM_END)
			{
			src_len += d_stream.total_in;
			dest_len += d_stream.total_out;

			if(src_len < srcLen)
				{

				inflateEnd(&d_stream);

				memset(&d_stream, 0, sizeof(d_stream));

				d_stream.next_in  = &src[src_len];
				d_stream.avail_in = srcLen-src_len;
				d_stream.next_out = &dst[dest_len]; 
				d_stream.avail_out = *destLen-dest_len;
				continue;
				}
			*destLen = dest_len;
			return 0;
			}

		inflateEnd(&d_stream);
		if(dest_len==0)
			{
			*destLen = dest_len;
			return -1;
			}
		else
			{
			*destLen = dest_len;
			return 0;
			}



		}

/*	while(1)
		{
		err = inflateInit2(&d_stream, 47); 


		while (d_stream.total_out < *destLen && d_stream.total_in < srcLen) 
			{
			d_stream.avail_in = d_stream.avail_out = 1;
			err = inflate(&d_stream, Z_NO_FLUSH);
			if (err == Z_STREAM_END) break;
			if (err < Z_OK) break;
			}



		if(err < Z_OK)
			{
			return -1;
			}
	
	
		err = inflateEnd(&d_stream); 

		}*/

	*destLen = d_stream.total_out;

	return 	Z_OK;
	}
